diff --git a/game/client/setup_bg.sh b/game/client/setup_bg.sh
new file mode 100644
index 000000000..25860dba5
--- /dev/null
+++ b/game/client/setup_bg.sh
@@ -0,0 +1,29 @@
+#!/bin/bash
+
+ROOT_DIR=./src/main/resources/bg
+
+for filename in "${ROOT_DIR}"/*.png; do
+    if ! magick identify "${filename}" | grep "512x256" > /dev/null; then
+        echo "${filename}"
+        magick "${filename}" \
+            -define filter:blur=3 \
+            -define png:compression-level=9 \
+            -define png:format=png24 \
+            -define png:compression-strategy=3 \
+            -filter Lagrange \
+            -resize 512 \
+            -gravity center \
+            -crop 512x256+0+0 \
+            +repage \
+            "${filename}"
+    fi
+done
+
+printf "{\n" > "${ROOT_DIR}"/backgrounds.json
+printf "\t\"replace\": false,\n" >> "${ROOT_DIR}"/backgrounds.json
+printf "\t\"backgrounds\": [\n" >> "${ROOT_DIR}"/backgrounds.json
+for filename in "${ROOT_DIR}"/*.png; do
+    printf "\t\t\"$(basename -s .png "${filename}")\",\n" >> "${ROOT_DIR}"/backgrounds.json
+done
+printf "\t]\n" >> "${ROOT_DIR}"/backgrounds.json
+printf "}\n" >> "${ROOT_DIR}"/backgrounds.json
diff --git a/game/client/src/main/java/net/minecraft/client/Minecraft.java b/game/client/src/main/java/net/minecraft/client/Minecraft.java
index d219fe60f..cf695d47a 100644
--- a/game/client/src/main/java/net/minecraft/client/Minecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/Minecraft.java
@@ -81,6 +81,7 @@ import net.minecraft.client.sound.SoundRepository;
 import org.jetbrains.annotations.Nullable;
 
 import org.lwjgl.LWJGLException;
+import org.lwjgl.glfw.GLFW;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.input.Mouse;
 import org.lwjgl.opengl.GL11;
@@ -525,6 +526,7 @@ public class Minecraft
         texturePackList = new TexturePackList(this, mcDataDir);
         textureManager = new TextureManager(this, texturePackList, gameSettings);
 
+        TooltipElement.reloadStyles(texturePackList);
         SoundRepository.initialize(this);
 
         // Show load screen as early as possible
@@ -2283,7 +2285,7 @@ public class Minecraft
         z *= Dimension.getCoordScale(lastDim, newDim);
         thePlayer.moveTo(x, y, z, thePlayer.yRot, thePlayer.xRot);
         ChunkCoordinates newCoordinates = new ChunkCoordinates(MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z));
-        if (thePlayer.dimensionEnterCoordinate != null) {
+        if (this.thePlayer.isAlive() && this.thePlayer.dimensionEnterCoordinate != null) {
             double dx = thePlayer.dimensionEnterCoordinate.x - x;
             double dy = thePlayer.dimensionEnterCoordinate.y - y;
             double dz = thePlayer.dimensionEnterCoordinate.z - z;
@@ -2706,7 +2708,7 @@ public class Minecraft
                 }
                 case "--gameDir": {
                     try {
-                        gameDirectory = args[pointer + 1];
+                        minecraftDir = new File(args[pointer + 1]);
                         pointer++;
                     } catch (Exception e) {
                         e.printStackTrace();
@@ -2825,8 +2827,24 @@ public class Minecraft
 
         return INSTANCE != null? (int) (INSTANCE.gameSettings.autosaveTimer.value * 24) * 5 : 0;
     }
-    
+
+    @Override
+    public void copyToClipboard(String str) {
+        GLFW.glfwSetClipboardString(this.gameWindow.getHandle(), str);
+    }
+
+    @Override
+    public String readFromClipboard() {
+        return GLFW.glfwGetClipboardString(this.gameWindow.getHandle());
+    }
+
     public static Minecraft getMinecraft() {
         return INSTANCE;
     }
+
+    static {
+        // This fixes a bug on macOS where the game doesn't start properly.
+        // Mojang does the exact same as of 1.21.4, so this is reasonably legit.
+        System.setProperty("java.awt.headless", "true");
+    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ExceptionPopupElement.java b/game/client/src/main/java/net/minecraft/client/gui/ExceptionPopupElement.java
index d867b5793..21ffbd4e9 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ExceptionPopupElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ExceptionPopupElement.java
@@ -4,8 +4,10 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.popup.PopupScreen;
 import net.minecraft.client.gui.popup.PopupBuilder;
 import net.minecraft.client.gui.popup.PopupCloseListener;
+import net.minecraft.core.Global;
 import net.minecraft.core.net.command.TextFormatting;
 import org.lwjgl.Sys;
+import org.lwjgl.glfw.GLFW;
 import org.lwjgl.opengl.GL11;
 
 import java.awt.*;
@@ -166,18 +168,11 @@ public class ExceptionPopupElement {
                     mc.hasCrashed = false;
                     break;
                 case 1:
-                    Toolkit.getDefaultToolkit()
-                            .getSystemClipboard()
-                            .setContents(
-                                    new StringSelection(message),
-                                    null
-                            );
+                    Global.accessor.copyToClipboard(message);
                     mc.hasCrashed = false;
                     break;
                 case 2:
-                    Toolkit.getDefaultToolkit()
-                            .getSystemClipboard()
-                            .setContents(new StringSelection(message), null);
+                    Global.accessor.copyToClipboard(message);
                     mc.shutdownMinecraftApplet();
                     break;
             }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenPhotoMode.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenPhotoMode.java
index 0b7619178..f0707cedd 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenPhotoMode.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenPhotoMode.java
@@ -2,6 +2,7 @@ package net.minecraft.client.gui;
 
 import net.minecraft.client.gui.modelviewer.elements.ListenerButtonElement;
 import net.minecraft.client.input.controller.ControllerInput;
+import net.minecraft.client.util.helper.FileOpener;
 import net.minecraft.core.Global;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Utils;
@@ -141,7 +142,7 @@ public class ScreenPhotoMode extends Screen
         buttonOpenScreenshotFolder.setActionListener(() -> {
             File f = new File(mc.getMinecraftDir(), "screenshots");
             f.mkdirs();
-            Utils.openDirectory(f);
+            FileOpener.open(f);
         });
 
         buttonCenterScreen = new ButtonElement(10, width - 120, 0, 120, 20, i18n.translateKey("gui.photo_mode.button.center_camera"));
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenSoundTest.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenSoundTest.java
index 64d74e5e5..cda236899 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenSoundTest.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenSoundTest.java
@@ -7,6 +7,7 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.sound.SoundEngine;
 import net.minecraft.client.sound.SoundEvent;
 import net.minecraft.client.sound.SoundRepository;
+import net.minecraft.client.util.helper.FileOpener;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Utils;
@@ -95,7 +96,7 @@ public class ScreenSoundTest extends Screen {
 
 
         add(new ListenerButtonElement(30, BUTTON_SPACING, bottom - (BUTTON_SPACING + 20), 20, 20, "")
-            .setActionListener(() -> Utils.openDirectory(new File(mc.getMinecraftDir(), "resources")))
+            .setActionListener(() -> FileOpener.open(new File(mc.getMinecraftDir(), "resources")))
             .setTextures("minecraft:gui/misc/button_folder", "minecraft:gui/misc/button_folder_highlighted", "minecraft:gui/misc/button_folder"));
 
         add(new ListenerButtonElement(31, 20 + BUTTON_SPACING * 2, bottom - (BUTTON_SPACING + 20), 20, 20, "V"))
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenTextureViewer.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenTextureViewer.java
index 13e350144..d266bd799 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenTextureViewer.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenTextureViewer.java
@@ -5,6 +5,7 @@ import net.minecraft.client.gui.modelviewer.elements.ListenerButtonElement;
 import net.minecraft.client.gui.modelviewer.elements.IListenerElement;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texture.Texture;
+import net.minecraft.client.util.helper.FileOpener;
 import net.minecraft.client.util.helper.Textures;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.util.helper.Utils;
@@ -90,7 +91,7 @@ public class ScreenTextureViewer extends Screen {
         add(new ListenerButtonElement(12, 40 + BUTTON_SPACING * 3, bottom - BUTTON_SPACING - 20, 20, 20, "D")
             .setActionListener(() -> {
                 Textures.dumpTextures();
-                Utils.openDirectory(new File("dumpTextures"));
+                FileOpener.open(new File("dumpTextures"));
             })
         );
         add(new ListenerButtonElement(13, 60 + BUTTON_SPACING * 4, bottom - BUTTON_SPACING - 20, 20, 20, "T")
diff --git a/game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java b/game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java
index f768851c5..8f77ea0b0 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java
@@ -1,25 +1,51 @@
 package net.minecraft.client.gui;
 
+import com.google.gson.JsonArray;
+import com.google.gson.JsonElement;
+import com.google.gson.JsonObject;
+import com.google.gson.JsonParser;
+import com.google.gson.stream.JsonReader;
+import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.client.render.texturepack.TexturePack;
+import net.minecraft.client.render.texturepack.TexturePackList;
 import net.minecraft.core.WeightedRandomBag;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryTrommel;
 import net.minecraft.core.data.registry.recipe.RecipeSymbol;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.client.option.enums.TooltipStyle;
 import net.minecraft.client.render.Font;
-import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.player.inventory.slot.Slot;
 import net.minecraft.core.player.inventory.slot.SlotResult;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.client.gui.guidebook.SlotGuidebook;
+import org.jetbrains.annotations.NotNull;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.GL11;
 
 import com.mojang.nbt.tags.CompoundTag;
+import org.slf4j.Logger;
+
+import java.io.IOException;
+import java.io.InputStream;
+import java.io.InputStreamReader;
+import java.util.ArrayList;
+import java.util.Collection;
+import java.util.HashMap;
+import java.util.HashSet;
+import java.util.List;
+import java.util.Map;
+import java.util.Set;
 
 public class TooltipElement extends Gui
 {
+    protected final static Logger LOGGER = LogUtils.getLogger();
+    public final static Map<String, Style> styleMap = new HashMap<>();
+    public final static List<String> stylesIdList = new ArrayList<>();
+    protected final static Style defaultStyle = new Style("default", "default", 3, 3, 3, 3);
+
     Minecraft mc;
     Font fr;
 
@@ -57,9 +83,9 @@ public class TooltipElement extends Gui
         x += offsetX;
         y += offsetY;
 
-        int padding = getPadding();
+        final int padding = getPadding();
 
-        drawBackground(x, y, x + width + padding * 2, y + height + padding * 2);
+        drawBackground(x, y, x + width, y + height);
 
 
         for(int i = 0; i < lines.length; i++)
@@ -68,12 +94,7 @@ public class TooltipElement extends Gui
         }
     }
     public int getPadding(){
-        int paddingExtra = 0;
-        if (mc.gameSettings.tooltipStyle.value != TooltipStyle.DEFAULT)
-        {
-            paddingExtra = 1;
-        }
-        return BASE_PADDING + paddingExtra;
+        return BASE_PADDING;
     }
     public int[] drawBackground(int x, int y, int offsetX, int offsetY, int width, int height){
 //        int targetOffset = 0;
@@ -91,126 +112,22 @@ public class TooltipElement extends Gui
         x += offsetX;
         y += offsetY;
 
-        int padding = getPadding();
-
-        return drawBackground(x, y, x + width + padding * 2, y + height + padding * 2);
+        return drawBackground(x, y, x + width, y + height);
     }
 
-    private int[] drawBackground(int minX, int minY, int maxX, int maxY)
+    private int[] drawBackground(final int minX, final int minY, final int maxX, final int maxY)
     {
-        if(mc.gameSettings.tooltipStyle.value == TooltipStyle.MODERN) {
-        	return drawBackgroundModern(minX, minY, maxX, maxY);
-        }
-        
-        int topLeftCornerX = minX;
-        int topLeftCornerY = minY;
-        int bottomLeftCornerX = minX;
-        int bottomLeftCornerY = maxY - 7;
-        int topRightCornerX = maxX - 7;
-        int topRightCornerY = minY;
-        int bottomRightCornerX = maxX - 7;
-        int bottomRightCornerY = maxY - 7;
-        int horWidth = (maxX - minX) - 14;
-        int vertHeight = (maxY - minY) - 14;
-        int horWidth2 = (maxX - minX) - 6;
-        int vertHeight2 = (maxY - minY) - 6;
-
-        Tessellator tl = Tessellator.instance;
-
-        mc.textureManager.bindTexture(mc.textureManager.loadTexture(mc.gameSettings.tooltipStyle.value.getFilePath()));
-
-        GL11.glEnable(GL11.GL_BLEND);
-        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-
-        tl.startDrawingQuads();
-
-        // Draw corners
-        // Top left
-        tl.drawRectangleWithUV(topLeftCornerX,      topLeftCornerY,     7, 7, 0 / 32F, 0 / 32F, 7 / 32F, 7 / 32F);
-        // Bottom left
-        tl.drawRectangleWithUV(bottomLeftCornerX,   bottomLeftCornerY,  7, 7, 0 / 32F, 7 / 32F, 7 / 32F, 7 / 32F);
-        // Top right
-        tl.drawRectangleWithUV(topRightCornerX,     topRightCornerY,    7, 7, 7 / 32F, 0 / 32F, 7 / 32F, 7 / 32F);
-        // Bottom right
-        tl.drawRectangleWithUV(bottomRightCornerX,  bottomRightCornerY, 7, 7, 7 / 32F, 7 / 32F, 7 / 32F, 7 / 32F);
-
-        // Draw top
-        for (int x = minX + 7; x < minX + 7 + (horWidth / 11) * 11; x += 11)
-        {
-            tl.drawRectangleWithUV(x, minY, 11, 3, 14 / 32F, 0 / 32F, 11 / 32F, 3 / 32F);
-        }
-        int finalWidth = horWidth - ((horWidth / 11) * 11);
-        tl.drawRectangleWithUV(topRightCornerX - finalWidth, minY, finalWidth, 3, 14 / 32F, 0 / 32F, finalWidth / 32F, 3 / 32F);
+        final Style style = styleMap.getOrDefault(this.mc.gameSettings.tooltipStyle.value, defaultStyle);
+        if (style != null) {
+            GL11.glEnable(GL11.GL_BLEND);
+            GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
 
-        // Draw bottom
-        for (int x = minX + 7; x < minX + 7 + (horWidth / 11) * 11; x += 11)
-        {
-            tl.drawRectangleWithUV(x, maxY - 3, 11, 3, 14 / 32F, 11 / 32F, 11 / 32F, 3 / 32F);
-        }
-        tl.drawRectangleWithUV(bottomRightCornerX - finalWidth, maxY - 3, finalWidth, 3, 14 / 32F, 11 / 32F, finalWidth / 32F, 3 / 32F);
+            drawGuiIcon(minX, minY, maxX - minX + BASE_PADDING * 2, maxY - minY + BASE_PADDING * 2, style.getInnerIcon());
+            drawGuiIcon(minX - style.paddingLeft, minY - style.paddingTop, maxX - minX + BASE_PADDING * 2 + style.paddingLeft + style.paddingRight, maxY - minY + BASE_PADDING * 2 + style.paddingTop + style.paddingBottom, style.getBorderIcon());
 
-        // Draw left
-        for (int y = minY + 7; y < minY + 7 + (vertHeight / 11) * 11; y += 11)
-        {
-            tl.drawRectangleWithUV(minX, y, 3, 11, 0 / 32F, 14 / 32F, 3 / 32F, 11 / 32F);
+            GL11.glDisable(GL11.GL_BLEND);
         }
-        int finalHeight = vertHeight - ((vertHeight / 11) * 11);
-        tl.drawRectangleWithUV(minX, bottomLeftCornerY - finalHeight, 3, finalHeight, 0 / 32F, 14 / 32F, 3 / 32F, finalHeight / 32F);
-
-        // Draw right
-        for (int y = minY + 7; y < minY + 7 + (vertHeight / 11) * 11; y += 11)
-        {
-            tl.drawRectangleWithUV(maxX - 3, y, 3, 11, 11 / 32F, 14 / 32F, 3 / 32F, 11 / 32F);
-        }
-        tl.drawRectangleWithUV(maxX - 3, bottomRightCornerY - finalHeight, 3, finalHeight, 11 / 32F, 14 / 32F, 3 / 32F, finalHeight / 32F);
-
-        // Draw background
-        for (int x = minX + 3; x < minX + 3 + (horWidth2 / 8) * 8; x += 8)
-        {
-            for (int y = minY + 3; y < minY + 3 + (vertHeight2 / 8) * 8; y += 8)
-            {
-                tl.drawRectangleWithUV(x, y, 8, 8, 14 / 32F, 14 / 32F, 8 / 32F, 8 / 32F);
-            }
-        }
-        int finalHeight2 = vertHeight2 - ((vertHeight2 / 8) * 8);
-        int finalWidth2 = horWidth2 - ((horWidth2 / 8) * 8);
-        for (int x = minX + 3; x < minX + 3 + (horWidth2 / 8) * 8; x += 8)
-        {
-            tl.drawRectangleWithUV(x, maxY - 3 - finalHeight2, 8, finalHeight2, 14 / 32F, 14 / 32F, 8 / 32F, finalHeight2 / 32F);
-        }
-        for (int y = minY + 3; y < minY + 3  + (vertHeight2 / 8) * 8; y += 8)
-        {
-            tl.drawRectangleWithUV(maxX - 3 - finalWidth2, y, finalWidth2, 8, 14 / 32F, 14 / 32F, finalWidth2 / 32F, 8 / 32F);
-        }
-        tl.drawRectangleWithUV(maxX - 3 - finalWidth2, maxY - 3 - finalHeight2, finalWidth2, finalHeight2, 14 / 32F, 14 / 32F, finalWidth / 32F, finalWidth2 / 32F);
-
-        tl.draw();
-
-        GL11.glDisable(GL11.GL_BLEND);
-        return new int[]{topLeftCornerX, topLeftCornerY};
-    }
-    
-    private int[] drawBackgroundModern(int minX, int minY, int maxX, int maxY) {
-    	int x = minX + 4;
-    	int y = minY + 4;
-    	int width = maxX - minX - 8;
-    	int height = maxY - minY - 8;
-    	
-		int bgColor = 0xf0100010;
-		int lineColorTop = 0x505000ff;
-		int lineColorBottom = (lineColorTop & 0xfefefe) >> 1 | lineColorTop & 0xff000000;
-    	
-    	drawGradientRect(x - 3, y - 4, x + width + 3, y - 3, bgColor, bgColor);
-		drawGradientRect(x - 3, y + height + 3, x + width + 3, y + height + 4, bgColor, bgColor);
-		drawGradientRect(x - 3, y - 3, x + width + 3, y + height + 3, bgColor, bgColor);
-		drawGradientRect(x - 4, y - 3, x - 3, y + height + 3, bgColor, bgColor);
-		drawGradientRect(x + width + 3, y - 3, x + width + 4, y + height + 3, bgColor, bgColor);
-		
-		drawGradientRect(x - 3, (y - 3) + 1, (x - 3) + 1, (y + height + 3) - 1, lineColorTop, lineColorBottom);
-		drawGradientRect(x + width + 2, (y - 3) + 1, x + width + 3, (y + height + 3) - 1, lineColorTop, lineColorBottom);
-		drawGradientRect(x - 3, y - 3, x + width + 3, (y - 3) + 1, lineColorTop, lineColorTop);
-		drawGradientRect(x - 3, y + height + 2, x + width + 3, y + height + 3, lineColorBottom, lineColorBottom);
-        return new int[]{x - 3, y - 4};
+        return new int[]{minX, minY};
     }
 
 	public String getTooltipText(ItemStack itemStack, boolean showDescription, Slot slot) {
@@ -251,9 +168,9 @@ public class TooltipElement extends Gui
                 if(((SlotGuidebook) slot).recipe != null) {
                     if (((SlotGuidebook) slot).recipe instanceof RecipeEntryTrommel) {
                         RecipeSymbol input = (RecipeSymbol) ((SlotGuidebook) slot).recipe.getInput();
-                        if(!input.matches(slot.getItem())){
+                        if(!input.matches(slot.getItemStack())){
                             WeightedRandomBag<?> bag = (WeightedRandomBag<?>) ((SlotGuidebook) slot).recipe.getOutput();
-                            double percent = bag.getAsPercentage(slot.getItem());
+                            double percent = bag.getAsPercentage(slot.getItemStack());
                             text.append('\n').append(TextFormatting.LIGHT_GRAY).append(String.format("%.2f", percent)).append("%");
                         }
                     }
@@ -351,4 +268,112 @@ public class TooltipElement extends Gui
         return string.toString();
     }
 
+    public static void reloadStyles(final @NotNull TexturePackList packList) {
+        styleMap.clear();
+        stylesIdList.clear();
+
+
+        final Collection<String> styleIds = new ArrayList<>();
+        for (int i = packList.selectedPacks.size() - 1; i >= 0; i--) {
+            final TexturePack pack = packList.selectedPacks.get(i);
+            try (final InputStream stylesStream = pack.getResourceAsStream("/assets/minecraft/textures/gui/sprites/tooltip/styles.json")) {
+                if (stylesStream != null) {
+                    final JsonObject stylesListObject = JsonParser.parseReader(new InputStreamReader(stylesStream)).getAsJsonObject();
+                    final boolean replace = stylesListObject.has("replace") ? stylesListObject.get("replace").getAsBoolean() : false;
+                    if (replace) styleIds.clear();
+                    final JsonArray styles = stylesListObject.getAsJsonArray("styles");
+                    for (final JsonElement element : styles) {
+                        final String styleId = element.getAsString();
+                        if (!styleIds.contains(styleId)) {
+                            styleIds.add(styleId);
+                        }
+                    }
+                }
+            } catch (final IOException ioException) {
+                LOGGER.error("Failed to load styles data!", ioException);
+            } catch (final RuntimeException runtimeException) {
+                LOGGER.error("Error occurred while parsing 'styles.json'!", runtimeException);
+            }
+        }
+        styleIds.add("default");
+
+        for (final String styleId : styleIds) {
+            JsonObject properties = null;
+            try (final InputStream propertiesStream = packList.getResourceAsStream("/assets/minecraft/textures/gui/sprites/tooltip/" + styleId + "/properties.json")) {
+                if (propertiesStream != null) {
+                    properties = JsonParser.parseReader(new JsonReader(new InputStreamReader(propertiesStream))).getAsJsonObject();
+                }
+            } catch (final IOException ioException) {
+                LOGGER.error("Failed to load style '{}' properties json!", styleId, ioException);
+            } catch (final RuntimeException runtimeException) {
+                LOGGER.error("Error occurred while parsing '{}/properties.json'!", styleId, runtimeException);
+            }
+            final Style style;
+            if (properties == null) {
+                style = new Style(styleId, String.format("options.tooltipStyle.%s", styleId), 3, 3, 3, 3);
+            } else {
+                final String key = properties.has("key") ? properties.get("key").getAsString() : String.format("options.tooltipStyle.%s", styleId);
+                final int top;
+                final int bottom;
+                final int left;
+                final int right;
+                if (properties.has("padding")) {
+                    final JsonElement padding = properties.get("padding");
+                    if (padding.isJsonPrimitive()) {
+                        top = bottom = left = right = padding.getAsInt();
+                    } else {
+                        final JsonObject paddingObject = padding.getAsJsonObject();
+                        top = paddingObject.has("top") ? paddingObject.get("top").getAsInt() : 3;
+                        bottom = paddingObject.has("bottom") ? paddingObject.get("bottom").getAsInt() : 3;
+                        left = paddingObject.has("left") ? paddingObject.get("left").getAsInt() : 3;
+                        right = paddingObject.has("right") ? paddingObject.get("right").getAsInt() : 3;
+                    }
+                } else {
+                    top = bottom = left = right = 3;
+                }
+                style = new Style(styleId, key, top, bottom, left, right);
+            }
+            styleMap.put(styleId, style);
+            stylesIdList.add(styleId);
+        }
+        if (!styleMap.containsKey("default")) {
+            styleMap.put("default", defaultStyle);
+            stylesIdList.add("default");
+        }
+        if (Minecraft.getMinecraft().gameSettings.tooltipStyle.getValueIndex() == -1) {
+            Minecraft.getMinecraft().gameSettings.tooltipStyle.set("default");
+        }
+    }
+
+    public static class Style {
+        public final String id;
+        public final String translationKey;
+        public final int paddingTop;
+        public final int paddingBottom;
+        public final int paddingLeft;
+        public final int paddingRight;
+
+        private final IconCoordinate innerIcon;
+        private final IconCoordinate borderIcon;
+
+        public Style(final String id, final String translationKey, final int paddingTop, final int paddingBottom, final int paddingLeft, final int paddingRight) {
+            this.id = id;
+            this.translationKey = translationKey;
+            this.paddingTop = paddingTop;
+            this.paddingBottom = paddingBottom;
+            this.paddingLeft = paddingLeft;
+            this.paddingRight = paddingRight;
+
+            this.innerIcon = TextureRegistry.getTexture("minecraft:gui/tooltip/" + id + "/inner");
+            this.borderIcon = TextureRegistry.getTexture("minecraft:gui/tooltip/" + id + "/border");
+        }
+
+        public IconCoordinate getInnerIcon() {
+            return this.innerIcon;
+        }
+
+        public IconCoordinate getBorderIcon() {
+            return this.borderIcon;
+        }
+    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/chat/GuiElementChatSuggestions.java b/game/client/src/main/java/net/minecraft/client/gui/chat/GuiElementChatSuggestions.java
index 53731bc4c..fa1b9f38d 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/chat/GuiElementChatSuggestions.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/chat/GuiElementChatSuggestions.java
@@ -198,17 +198,14 @@ public class GuiElementChatSuggestions extends Gui {
         return commandUsage;
     }
 
-    public void keyTyped(char c, int key) {
-        int mouseX = getScaledMouseX(this.mc);
-        int mouseY = getScaledMouseY(this.mc) - 1;
-
-        int TAB = 15;
-        int LEFT_SHIFT = 42;
+    public void keyTyped(final char c, final int key) {
+        final int mouseX = getScaledMouseX(this.mc);
+        final int mouseY = getScaledMouseY(this.mc) - 1;
 
-        if (key == TAB) {
+        if (key == Keyboard.KEY_TAB) {
             if (this.commandIndex == -1 && this.isHoveringOverSuggestions(mouseX, mouseY)) {
                 this.cycleToSuggestion(this.getIndexOfSuggestionBeingHoveredOver(mouseX, mouseY).get());
-            } else if (Keyboard.isKeyDown(LEFT_SHIFT)) {
+            } else if (Keyboard.isKeyDown(Keyboard.KEY_LSHIFT)) {
                 this.cycleThroughSuggestions(-1);
             } else {
                 this.cycleThroughSuggestions();
@@ -251,15 +248,15 @@ public class GuiElementChatSuggestions extends Gui {
         }
     }
 
-    private boolean shouldApplySuggestion(char c, int key) {
+    private boolean shouldApplySuggestion(final char c, final int key) {
         return this.textField.isCharacterAllowed(c)
-            || ((key == 46 || key == 47) && (Keyboard.isKeyDown(29) || Keyboard.isKeyDown(157)))
-            || key == 199
-            || key == 207
-            || key == 203
-            || key == 205
-            || key == 14
-            || key == 211;
+            || ((key == Keyboard.KEY_C || key == Keyboard.KEY_V) && (Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL)))
+            || key == Keyboard.KEY_HOME
+            || key == Keyboard.KEY_END
+            || key == Keyboard.KEY_LEFT
+            || key == Keyboard.KEY_RIGHT
+            || key == Keyboard.KEY_BACK
+            || key == Keyboard.KEY_DELETE;
     }
 
     private void finishUpdatingSuggestions() {
@@ -400,7 +397,7 @@ public class GuiElementChatSuggestions extends Gui {
             return serverSuggestions.get(CommandManagerPacketKeys.SUGGESTION_CONTEXT_START_POS).getAsInt();
         }
         try {
-            return this.parseResults != null ? this.parseResults.getContext().findSuggestionContext(this.tablessCursor).startPos : 0;
+            return this.parseResults != null ? this.parseResults.getContext().findSuggestionContext(Math.max(this.tablessCursor, 1)).startPos : 0; // TODO possibly investigate why tabless cursor needs to be bound to [1, inf)
         } catch (IllegalStateException e) {
             LOGGER.error("", e);
             return 0;
